import java.io.File;
import javax.swing.filechooser.FileFilter;

public class ArbitraryFileFilter extends FileFilter
{
    private String extension;
    private String description;

    public ArbitraryFileFilter(String extension, String description)
    {
	super();
	this.extension = extension;
	this.description = description;
    }
    
    public boolean accept(File f)
    {
	if (f.isDirectory())
	    return true;

	String fileExtension = getExtension(f);
	if ( (fileExtension != null) && (fileExtension.equals(extension)) )
	    return true;
	else
	    return false;
    }

    public String getDescription()
    {
	return description;
    }

    public static String getExtension(File f) {
        String ext = null;
        String s = f.getName();
        int i = s.lastIndexOf('.');

        if (i > 0 &&  i < s.length() - 1) {
            ext = s.substring(i+1).toLowerCase();
        }
        return ext;
    }
}
