import java.io.*;
import java.util.HashMap;
import java.util.StringTokenizer;
import java.util.NoSuchElementException;

import javax.vecmath.*;

public class BeaconLocationParser
{
    public static HashMap loadFile(String filename)
	throws IOException
    {
	StringTokenizer strtok;
	
	HashMap beaconLocations = new HashMap(5);
	String space; // or "name" of beacon
	String id;
	float x, y, z;

	FileReader fr = new FileReader(filename);
	BufferedReader br = new BufferedReader(fr);
	String line = br.readLine();
	while (line != null)
	    {
		if (line.charAt(0) != '#')
		    {
			try
			    {
				strtok = new StringTokenizer(line);
				space = strtok.nextToken();
				id = strtok.nextToken();
				x = Float.parseFloat(strtok.nextToken());
				y = Float.parseFloat(strtok.nextToken());
				z = Float.parseFloat(strtok.nextToken());
				beaconLocations.put(space + " " + id,
						    new Vector3f(x,y,z));
			    }
			catch (NoSuchElementException nee)
			    {
				throw new IOException("Badly formatted file");
			    }
		    }
		line = br.readLine();
	    }
	return beaconLocations;
    }
}
