import java.util.*;
import java.io.*;
import java.net.*;

public class Cricket3DInterpreter implements Runnable
{
    private Cricket3DGUI gui;
    private Socket socket;
    private BufferedReader socketInput;
    private BufferedWriter socketOutput;
    
    private boolean interpreting;

    public Cricket3DInterpreter(Socket iSocket, Cricket3DGUI iGUI)
	throws IOException
    {
	interpreting = true;
        gui = iGUI;
        socket = iSocket;
	socketInput
	    = new BufferedReader(new InputStreamReader
				 (socket.getInputStream()));
	socketOutput
	    = new BufferedWriter(new OutputStreamWriter
				 (socket.getOutputStream()));
    }

    public void run()
    {
	// Bad style but it works.  The elegant way fails
	// line <- input line from stream
	// assignment operator outputs itself
	// test to see if it's null
	String line = "";
	try
	    {
		while (interpreting)
		    {
			line = socketInput.readLine();
			handleInput(line);
		    }
	    }
	catch (IOException ie)
	    {
		gui.writeGUI("Connection to client lost");
		try
		    { socket.close(); }
		catch (IOException iee)
		    { gui.writeGUI("Could not close socket, sorry!"); }
	    }
	try
	    {
                socket.close();
                gui.writeGUI("Disconnected");
            }
	catch (IOException ieee)
	    { gui.writeGUI("Could not close socket, sorry!"); }
    }

    private synchronized void handleListener1
        (String line, StringTokenizer strtok)
    {
        String ip = "";
        int port = -1;
        try
            {
                ip = strtok.nextToken();
                port = Integer.parseInt(strtok.nextToken());
            }
        catch (NoSuchElementException nsee)
            { gui.writeGUI("Badly formatted command: " + line); }
        catch (NumberFormatException nfe)
            { gui.writeGUI("Badly formatted command: " + line); }
        CricketClient cricketClient1 =
            new CricketClient(ip, port, "Listener 1");
        try
            {
                cricketClient1.connect();
                gui.setCricketClient1(cricketClient1);
                gui.writeGUI("Listener 1 connected at: " + ip + ":" + port);
            }
        catch(IOException ie)
            {
                gui.writeGUI("Could not connect to listener at: "
                             + ip + ":" + port);
            }
        // TODO: setlisteneroneip/port??
    }

    private synchronized void handleListener2
        (String line, StringTokenizer strtok)
    {
        String ip = "";
        int port = -1;
        try
            {
                ip = strtok.nextToken();
                port = Integer.parseInt(strtok.nextToken());
            }
        catch (NoSuchElementException nsee)
            { gui.writeGUI("Badly formatted command: " + line); }
        catch (NumberFormatException nfe)
            { gui.writeGUI("Badly formatted command: " + line); }
        CricketClient cricketClient2 =
            new CricketClient(ip, port, "Listener 2");
        try
            {
                cricketClient2.connect();
                gui.setCricketClient2(cricketClient2);
                gui.writeGUI("Listener 2 connected at: " + ip + ":" + port);
            }
        catch(IOException ie)
            {
                gui.writeGUI("Could not connect to listener at: "
                             + ip + ":" + port);
            }
        // TODO: setlisteneroneip/port??
    }

    private synchronized void handleLaser(String line, StringTokenizer strtok)
    {
        String ip = "";
        int port = -1;
        try
            {
                ip = strtok.nextToken();
                port = Integer.parseInt(strtok.nextToken());
            }
        catch (NoSuchElementException nsee)
            { System.out.println("Badly formatted command: " + line); }
        catch (NumberFormatException nfe)
            { System.out.println("Badly formatted command: " + line); }
        LaserClient laserClient
            = new LaserClient(ip, port, "Laser");
        try
            {
                laserClient.connect();
                gui.setLaserClient(laserClient);
                gui.writeGUI("Laser connected at: " + ip + ":" + port);
            }
        catch(IOException ie)
            {
                gui.writeGUI("Could not connect to laser at: "
                             + ip + ":" + port);
            }
    }

    // TODO: need ack packets to tell them whether or not it really
    // started, so it can send start again instead of stop
    private synchronized void handleStart(String line, StringTokenizer strtok)
    {
        gui.startVisualization();
    }
    
    private synchronized void handleAddPoint
        (String line, StringTokenizer strtok)
    {
        String label = "xyz";
        try
            {
                label = strtok.nextToken();
                gui.addPoint(label);
            }
        catch (NoSuchElementException nsee) {}
        
    }

    private synchronized void handleSphereQuery
        (String line, StringTokenizer strtok)
    {
        try
            {
                float radius = Float.parseFloat(strtok.nextToken());
                System.out.println(gui.sphereQuery(radius));
            }
        catch (NoSuchElementException nsee)
            {
                System.out.println
                    ( "Badly formatted command: " + line );
            }
       
    }

    private synchronized void handleInput(String line)
    {
	StringTokenizer strtok = new StringTokenizer(line, " \n");
	String command = strtok.nextToken();
	String ip = null;
	int port = -1;
	String tempBLFilename;

	if (command.equals("listener1"))
            handleListener1(line, strtok);
	else if (command.equals("listener2"))
            handleListener2(line, strtok);
	else if (command.equals("laser"))
            handleLaser(line, strtok);
        else if (command.equals("start"))
            handleStart(line, strtok);
	else if (command.equals("blfilename"))
	    {
                /*
                  try { server.setBLFilename(strtok.nextToken()); }
                  catch (NoSuchElementException nsee)
                  { System.out.println("Badly formatted command"); }
                */
	    }
	else if (command.equals("disconnect"))
	    {
		interpreting = false;
		gui.writeGUI("Closing socket...");
	    }

	// database population here
	else if (command.equals("addpoint"))
	    {
                handleAddPoint(line, strtok);
	    }
        else if (command.equals("addpointcollection"))
            {
                
            }
        else if (command.equals("spherequery"))
            {
                handleSphereQuery(line, strtok);
            }
    }

}
