import java.io.IOException;
import java.awt.event.*;
import javax.vecmath.*;

public class FlashlightRepainter implements ActionListener
{
    private BeaconProcessor bp;
    private SocketPrinter sp;

    public FlashlightRepainter(BeaconProcessor bp)
    {
	this.bp = bp;
	try
	    {
		sp = new SocketPrinter(5005);
		sp.initComm();
	    }
	catch (IOException ie)
	    {
		System.out.println("Unable to create ServerSocket");
	    }
    }

    public void actionPerformed(ActionEvent e)
    {
	Vector3f eye = bp.getListener1Position();
	Vector3f target = bp.getDotPosition();
	float distance = bp.getLaserDistance();
	String repaintPacket = "" + eye.x + " " + eye.y + " "
	    + eye.z + " " + target.x + " " + target.y + " "
	    + target.z + " " + distance;
	sp.send(repaintPacket);
    }
}
