import java.util.*;

// TODO: support transforms if necessary
public class Room
{
    private final String name;
    private BoundingBox3f boundingBox;
    private HashMap rooms;
    private LinkedList triangles;

    public Room(String name)
    {
        this.name = name;
        rooms = new HashMap(3);
        triangles = new LinkedList();
        boundingBox = null;
    }

    public void addRoom(Room r)
    {
        rooms.put(r.getName(), r);
    }

    public void addTriangle(Triangle3f t)
    {
        triangles.add(t);
    }

    public String getName()
    {
        return name;
    }
    
    public HashMap getRooms()
    {
        return rooms;
    }

    public LinkedList getTriangles()
    {
        return triangles;
    }

    private void calculateBoundingBox()
    {
        LinkedList boundingBoxes = new LinkedList();
	boundingBoxes.addLast(BoundingBox3f.calculateFromTriangles(triangles));
        Room currentRoom;
        for (Iterator itr = rooms.values().iterator(); itr.hasNext();)
            {
                currentRoom = (Room)(itr.next());
                boundingBoxes.addLast(currentRoom.getBoundingBox());
            }
        boundingBox = BoundingBox3f.calculateFromBoundingBoxes(boundingBoxes);
    }
    
    public BoundingBox3f getBoundingBox()
    {
        if (boundingBox == null)
            calculateBoundingBox(); // use dynamic programming
        return boundingBox;
    }

}
