import java.util.*;
import java.net.*;
import java.io.*;

public class SocketPrinter
{
    private int port;
    private ServerSocket serverSocket;
    private Socket clientSocket;
    private InputStream inputStream;
    private OutputStream outputStream;
    private BufferedInputStream socketRead;
    private PrintStream socketWrite;

    public SocketPrinter(int iPort)
        throws IOException
    {
        this.port = iPort;
        serverSocket = new ServerSocket(port, 1);
    }

    public void initComm()
    {
        try
            {
                System.out.println("SocketPrinter accepting...");
                clientSocket = serverSocket.accept();
            }
        catch ( IOException ie )
            {
                System.out.println("Unable to accept connection");
                return;
            }
        try
            {
                inputStream = clientSocket.getInputStream();
                outputStream = clientSocket.getOutputStream();
                socketRead = new BufferedInputStream(inputStream);
                socketWrite = new PrintStream(outputStream);
            }
        catch ( IOException iie )
            {
                System.out.println("Unable to acquire stream I/O");
                try
                    {
                        clientSocket.close();
                    }
                catch ( IOException closeIE )
                    {
                        System.out.println("Unable to close socket");
                    }
            }
    }

    public void send(String s)
    {
	socketWrite.println(s);
    }

    public static void main(String[] args)
    {
        SocketPrinter sp;
        if (args.length < 1)
            {
                System.out.println("usage: java SocketPrinter <port>");
                System.exit(-1);
            }
        else
            {
                try
                    {
                        sp = new SocketPrinter(Integer.parseInt(args[0]));
                        sp.initComm();
                    }
                catch ( IOException ie )
                    {
                        System.out.println("Unable to create ServerSocket");
                    }
            }
    }
}
