#!/usr/bin/python2

import socket
import sys
import threading
import time

import gtk
import libglade

import LaserServer
import serial
import getip

class Cricket3DGUI_laser:

    def __init__(self):
        # TODO: query myLaser instead, same goes for the server!
                
        self.gladeXML = 'Cricket3DGUI_laser.glade'

        self.root = libglade.GladeXML(self.gladeXML,'mainWindow')
        self.quitHandler = { "on_mainWindow_destroy" : gtk.mainquit }
        self.root.signal_autoconnect(self.quitHandler)

        self.initializeState()
        self.initializeWidgets()
        self.connectWidgets()
        
        gtk.mainloop()

    def __del__(self):
        if self.laserServer != None:
            if self.laserServer.laserInterface != None:
                self.laserServer.laserInterface.__del__()
                # del self.laserInterface # power off laser gracefully
                # TODO: disconnect the server

    def initializeState(self):
        self.connectedToServer = 0
        self.pulseState = 0
        self.laserServer = None
        self.connectedToLaser = 0
        self.visualStarted = 0
        self.cricketdPort = 2948 # TODO: configurable?

    def initializeWidgets(self):
        self.serverTextEntry = self.root.get_widget('serverTextEntry')
        self.serverPortTextEntry = self.root.get_widget('serverPortTextEntry')
        self.laserSerialTextEntry = \
                                  self.root.get_widget('laserSerialTextEntry')
        self.laserPortTextEntry = self.root.get_widget('laserPortTextEntry')
        self.serverButton = self.root.get_widget('serverButton')
        self.laserServerButton = self.root.get_widget('laserServerButton')
        self.laserPowerButton = self.root.get_widget('laserPowerButton')
        self.trackingButton = self.root.get_widget('trackingButton')
        self.startButton = self.root.get_widget('startButton')

    def connectWidgets(self):
        self.serverButton.connect('clicked', self.serverHandler)
        self.laserServerButton.connect('clicked', self.laserServerHandler)
        self.laserPowerButton.connect('clicked', self.powerButtonHandler)
        self.trackingButton.connect('clicked', self.trackingButtonHandler)
        self.startButton.connect('clicked', self.startButtonHandler)

    def serverHandler(self, sourceButton):
        if self.connectedToServer == 1:
            self.socket.close()
        else:
            self.socket = socket.socket(socket.AF_INET, socket.SOCK_STREAM)
            serverIP = self.serverTextEntry.get_text()
            serverPort = self.serverPortTextEntry.get_text()
            self.socket.connect((serverIP, int(serverPort)))
            self.connectedToServer = 1
            self.socket.send('listener1 ' + getip.getIP() + ' ' +\
                             str(self.cricketdPort) + '\n')
            if self.connectedToLaser:
                self.socket.send('laser ' + getip.getIP() + ' ' +\
                                 self.laserServerPort + '\n')

    # TODO: port parameters!  some kind of menu
    def laserServerHandler(self, sourceButton):
        if self.connectedToLaser == 0:
            ser = self.laserSerialTextEntry.get_text()
            self.laserServerPort = self.laserPortTextEntry.get_text()
            try:
                self.laserServer = LaserServer.LaserServer\
                                   (int(self.laserServerPort), 1, ser)
                self.connectedToLaser = 1
                if self.connectedToServer == 1:
                    self.socket.send('laser ' + getip.getIP() + ' ' +\
                                     self.laserServerPort + '\n')
            except serial.serialutil.SerialException:
                print 'Error' # need a status bar
                self.connectedToLaser = 0
        else:
            del self.laserServer
            self.connectedToLaser = 0

    # TODO: query myLaser instead
    def powerButtonHandler(self, sourceButton):
        if self.connectedToLaser == 1:
            if self.laserServer.laserInterface.onState == 0:
                self.laserServer.laserInterface.on()
            else:
                self.laserServer.laserInterface.off()
        else:
            print 'Connect to Laser Server first'
                
    def distButtonHandler(self, sourceButton):
        self.laserInterface.dist()

    def pulseButtonHandler(self, sourceButton):
        if self.connectedToLaser == 0:
            self.writeStatusMessage('Connect to laser first')
        else:
            self.laserInterface.pulseSemaphore.acquire()
            if self.laserInterface.pulseState == 0:
                self.laserInterface.pulseSemaphore.release()
                self.laserInterface.pulseOn(self.pulsePeriodSpinner.get_value_as_float())
            else:
                self.laserInterface.pulseOff()
            self.laserInterface.pulseSemaphore.release()

    def trackingButtonHandler(self, sourceButton):
        if self.connectedToLaser == 1:
            if self.laserServer.laserInterface.trackingState == 0:
                self.laserServer.laserInterface.trackOn()
            else:
                self.laserServer.laserInterface.trackOff()
        else:
            # self.writeStatusMessage('Connect to laser first')
            print 'Connect to Laser First'


    def startButtonHandler(self, sourceButton):
        if self.visualStarted == 0 and self.connectedToServer == 1:
            print 'In Start BUtton Handler'
            self.socket.send('start\n')
            self.visualStarted = 1
            
cricket3DGUI_laser = Cricket3DGUI_laser()
