import string
import threading
import socket
import serial
import getip
import LaserInterface

# TODO: gracefully disconnect
# Probably use a semaphore around the while 1: of run of the server thread
# then just let it end, closing the socket first

# Protocol:
# input to LaserServer: first send two characters, denoting length of message
# then send message itself
# output: send just the message itself, terminated by \n

# need something to stop the server from listening, hmm...
class LaserServer(threading.Thread):

    def __init__(self, port=5003, numClients=1, deviceString='/dev/ttySA0',
                 baudrate=9600, bytesize=serial.SEVENBITS,
                 parity=serial.PARITY_EVEN, stopbits=serial.STOPBITS_ONE,
                 timeout=5, xonxoff=1, rtscts=0):
        threading.Thread.__init__(self)
        self.laserInterface = LaserInterface.LaserInterface\
                              (deviceString, baudrate,\
                               bytesize, parity, stopbits,\
                               timeout, xonxoff, rtscts)
        self.socket = socket.socket(socket.AF_INET, socket.SOCK_STREAM)
        self.ipaddress = getip.getIP()
        print 'Binding to: ' + self.ipaddress
        self.socket.bind((self.ipaddress, port))
        print 'Listening...'
        self.socket.listen(numClients)
        self.start()

    # TODO: ooh, that's how you stop the server, maybe
    def run(self):
        while 1:
            (clientSocket, clientAddress) = self.socket.accept()
            cthread = LaserServerThread(self, clientSocket)
            cthread.start()

    def __del__(self):
        self.socket.close()


class LaserServerThread(threading.Thread):

    def __init__(self, laserServer, clientSocket):
        threading.Thread.__init__(self)
        print 'Connected.'
        self.laserServer = laserServer
        self.clientSocket = clientSocket
        self.online = 1

    def __del__(self):
        self.laserServer.laserInterface.deregister(self.sendMessage)
        self.clientSocket.close()

    # Read from socket on blocking io
    def run(self):
        while self.online:
            numBytes = self.clientSocket.recv(2)
            msg = self.clientSocket.recv(int(numBytes))
            if msg == 'start':
                self.laserServer.laserInterface.register(self.sendMessage)
            elif msg == 'stop':
                self.laserServer.laserInterface.deregister(self.sendMessage)
                self.online = 0
        self.clientSocket.close()


    def sendMessage(self, msg):
        l = len(msg)
        if msg[l-1] != '\n':
            self.clientSocket.send(msg + '\n')
        else:
            self.clientSocket.send(msg)
