#!/usr/bin/python

import socket
import sys
import time

import gtk
import libglade

import getip

class Cricket3DGUI_nolaser:

    def __init__(self):
        # TODO: query myLaser instead, same goes for the server!
                
        self.gladeXML = 'Cricket3DGUI_nolaser.glade'

        self.root = libglade.GladeXML(self.gladeXML,'mainWindow')
        self.quitHandler = { "on_mainWindow_destroy" : gtk.mainquit }
        self.root.signal_autoconnect(self.quitHandler)

        self.initializeState()
        self.initializeWidgets()
        self.connectWidgets()
        
        gtk.mainloop()

    def initializeState(self):
        self.connectedToServer = 0
        self.visualStarted = 0
        self.cricketdPort = 2947 # TODO: configurable?

    def initializeWidgets(self):
        self.serverTextEntry = self.root.get_widget('serverTextEntry')
        self.serverPortTextEntry = self.root.get_widget('serverPortTextEntry')
        self.serverButton = self.root.get_widget('serverButton')
        self.startButton = self.root.get_widget('startButton')
        self.addPointButton = self.root.get_widget('addPointButton')
        self.sphereQueryButton = self.root.get_widget('sphereQueryButton')
        self.statusBox = self.root.get_widget('statusBox')

    def connectWidgets(self):
        self.serverButton.connect('clicked', self.serverHandler)
        self.startButton.connect('clicked', self.startButtonHandler)
        self.addPointButton.connect('clicked', self.addPointButtonHandler)

    # TODO: disconnect!
    def serverHandler(self, sourceButton):
        if self.connectedToServer == 1:
            self.socket.close()
        else:
            self.socket = socket.socket(socket.AF_INET, socket.SOCK_STREAM)
            serverIP = self.serverTextEntry.get_text()
            serverPort = self.serverPortTextEntry.get_text()
            self.socket.connect((serverIP, int(serverPort)))
            self.connectedToServer = 1
            self.socket.send('listener2 ' + getip.getIP() + ' ' +\
                             str(self.cricketdPort) + '\n')

    # TODO: get feedback and disable button
    def startButtonHandler(self, sourceButton):
        if self.visualStarted == 0 and self.connectedToServer == 1:
            self.statusBox.set_text(
            self.socket.send('start\n')
            self.visualStarted = 1

    def addPointButtonHandler(self, sourceButton):
        return
            
cricket3DGUI_nolaser = Cricket3DGUI_nolaser()
